/*global define, window*/

define([
    'testsuite/qunit',
    'jquery',

    './translation',
    '$ready!'
], function (QUnit, $) {
    QUnit.module('de_epages/externalcontent/ui/translation');

    QUnit.test('Test translation methods', 2, function () {
        $.each(['_create', 'destroy'], function (i, fn) {
            QUnit.equal(
                $.isFunction($.ui.externalcontentUiTranslation.prototype[fn]),
                true,
                fn + ' is a method of translation'
            );
        });
    });

    QUnit.test('Test translation', 8, function () {
        // add Google Widget
        $("#translationcontainer1").externalcontentUiTranslation({
            service : 'google'
        });

        QUnit.equal(
            $("#translationcontainer1").children().attr("id"),
            "google_translate_element",
            "the container <<Div>> has correctly been appended to the target. It has the ID google_translate_element"
        );

        QUnit.equal(
            $("body script[src*='translate.google.com/translate_a/element.js']").length,
            1,
            "The script for the Google has been loaded successfully"
        );

        $("#translationcontainer1").externalcontentUiTranslation("destroy");

        QUnit.equal(
            $("#translationcontainer1").children().length,
            0,
            "All Children of the target <<Div>>  of the Google Widget have been disappended after destroying the Widget"
        );

        window.google = {
            translate : {
                TranslateElement : function (obj,str) {
                    window.layout = obj.layout;
                    window.language = obj.pageLanguage;
                }
            }
        };

        window.google.translate.TranslateElement.InlineLayout = {SIMPLE: 'simple'};

        $("#translationcontainer3").externalcontentUiTranslation({
            service : 'google'
        });

        QUnit.equal(
            window.layout,
            "simple",
            "The second Google Widget recognises the already existing Google Object and calls the callback the passed layout is <simple>"
        );

        QUnit.equal(
            window.language,
            "de",
            "The second Google Widget recognises the already existing Google Object and calls the callback the passed language is <de>"
        );

        $("#translationcontainer3").externalcontentUiTranslation("destroy");

        QUnit.equal(
            $("#translationcontainer3").children().length,
            0,
            "All Children of the target <<Div>>  of the second Google Widget have been disappended after destroying the Widget"
        );

        $("#translationcontainer2").externalcontentUiTranslation({
            service : 'microsoft'
        });

        QUnit.equal(
            $("#translationcontainer2").children().attr("id"),
            "MicrosoftTranslatorWidget",
            "the container <<Div>> has correctly been appended to the target. It has the ID MicrosoftTranslatorWidget"
        );

        $("#translationcontainer2").externalcontentUiTranslation("destroy");

        QUnit.equal(
            $("#translationcontainer2").children().length,
            0,
            "All Children of the target <<Div>>  of the Microsoft Widget have been disappended after destroying the Widget"
        );
    });
});