var require, CKEDITOR_BASEPATH, CKEDITOR_AMD_REQUIRE;

(function () {

	// RequireJS config
	require = {
		baseUrl: "",

		paths: {

		},

		shim: {
			'backbone': {
				deps: ['underscore', 'jquery'],
				exports: 'Backbone'
			},
			'underscore': {
				exports: '_'
			},
			'fabric': {
				exports: 'fabric'
			},
			'ckeditor/ckeditor': {
				exports: 'CKEDITOR'
			},

			/*
			 * Qunit testsuite modules
			 */
			'testsuite/fake': {
				exports: 'FAKE'
			},
			'testsuite/simulate': {
				deps: ['jquery'],
				exports: 'jQuery'
			},
			'testsuite/sinon': {
				exports: 'sinon'
			},
			'testsuite/sinon/ie': {
				deps: ['testsuite/sinon'],
				exports: 'sinon'
			},
			'testsuite/sinon/qunit': {
				deps: ['testsuite/sinon', 'testsuite/qunit'],
				exports: 'sinon'
			},
			'testsuite/sinon/server': {
				deps: ['testsuite/sinon'],
				exports: 'sinon'
			},
			'testsuite/sinon/timers-ie': {
				deps: ['testsuite/sinon', 'testsuite/simulate/timers'],
				exports: 'sinon'
			},
			'testsuite/sinon/timers': {
				deps: ['testsuite/sinon'],
				exports: 'sinon'
			}
		},

		config: {
			'ep': {
				maxContentLength: 4096,
				debugLevel: 2,
				languageId: '2',
				language: 'de',
				locale: 'de_DE',
				objectId: 0,
				viewAction: 'MBO-ViewTestcase',
				storeFrontUrl: 'http://www.DemoShop.de/Shop.sf',
				protocolAndServer: 'http://www.DemoShop.de',
				javascriptRoot: "/WebRoot/StoreTypes/x.xx.x/Store/lib"
			},
			'jquery/i18n': {
				region: 'de-DE',
				currency: ['EUR', 'GBP']
			},
			'jquery/dict': {
				region: 'de'
			},
			'jquery/storage': {
				namspace: "0::"
			},
			'jquery/metaparse': {
				type: "data",
				name: "js",
				autoparse: false
			},
			"util/mime": {
				groups: {
					"image/*": "image/png,image/jpeg,image/jpg,image/gif,image/vnd.microsoft.icon,image/x-icon,image/x-win-bitmap",
					"document/*": "application/pdf,application/msword,application/vnd.ms-excel,application/rtf,application/vnd.openxmlformats-officedocument.wordprocessingml.document,application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
					"audio/*": "audio/mpeg,audio/x-ms-wma,audio/ogg,audio/flac,audio/x-ms-wma",
					"video/*": "video/x-msvideo,video/mp4,video/mpeg,video/x-ms-wmv,video/x-flv"
				}
			}
		}
	};

	CKEDITOR_BASEPATH = require.baseUrl + "/ckeditor/";

	CKEDITOR_AMD_REQUIRE = function (depends) {
		for (var i in depends) {
			depends[i] = (depends[i])
				.replace(CKEDITOR.basePath, "ckeditor/")
				.replace(/(\.js(\?.*)?$)/, "");
		}

		return require.apply(require, arguments);
	};


	/*
	 * Automated configuration setup
	 *
	 * Nothing to modify below
	 */

	var scriptNode = (function (nodes) {
		var i, node;

		// Detetect by base url daata attribute
		for (i in nodes) {
			node = nodes[i];

			if (node.dataset && node.dataset["baseUrl"]) {
				return node;
			}
		}

		// Alternative use first script node with src attribute
		for (i in nodes) {
			node = nodes[i];

			if (node.src) {
				return node;
			}
		}

		// Fall back use first script
		return node[0];
	}(document.getElementsByTagName('script'))),

		docUrl = location.href,

		mainUrl = docUrl.replace(/\.html.*$/, ""),

		baseUrl = (scriptNode.dataset && scriptNode.dataset["baseUrl"]) || (scriptNode.getAttribute("src") || "").replace(/^((?:\.\.\/)*).*$/, '$1'),

		folderLevel = 1,

		jscoverage = /lib\/(ep|de_epages)([^\/]+)/.exec(docUrl);

	extend = function (target, copy) {
		extend._(target, copy);
		return target;
	};

	// Extend method helper
	extend.c = (require || {});
	extend._ = function (target, copy) {
		for (var prop in copy) {
			if (copy[prop] instanceof Object) {
				extend._(target[prop] || (target[prop] = {}), copy[prop]);
			} else {
				target[prop] = copy[prop];
			}
		}
	};

	// Determinate the folderlevel by baseUrl
	baseUrl.replace(/\.\.\/?/g, function (all) {
		folderLevel++;
	});

	// Set absolute base url
	baseUrl = docUrl.replace(new RegExp('(\\/[^\\/]+){' + folderLevel + '}$', ''), '');

	// Set main url (module path)
	mainUrl = mainUrl.replace(baseUrl + '/', '');

	// Set main data attribute for RequireJS
	scriptNode.setAttribute("data-main", mainUrl);

	// Expose merged require config
	require = extend(require, arguments[0] || {});

	// Set base url in RequireJS config
	require.baseUrl = baseUrl;

	// Set base url for CKEDITOR
	CKEDITOR_BASEPATH = baseUrl + CKEDITOR_BASEPATH;

	// Map path for jscoverage mode
	if (jscoverage) {
		require.paths[jscoverage[1]] = jscoverage[1] + jscoverage[2];
	}

})(require);