package DE_EPAGES::Shop::t::Test;
use base 'DE_EPAGES::Shop::API::Test';
use Test::More;
use strict;

use constant SHOP_PACKAGE => 'DE_EPAGES::Shop::API::Object::Shop';
use constant DBI_PACKAGE => 'DE_EPAGES::Database::API::DBI';

plan tests => 9; # cleaup is called twice

sub test {
    my $self = shift;

    isa_ok( $self->shop, SHOP_PACKAGE, 'shop() called in test()' );
    isa_ok( $self->dbi, DBI_PACKAGE, 'dbi() called in test()' );
}

sub init {
    my $self = shift;

    isa_ok( $self->dbi, DBI_PACKAGE, 'dbi() called in init()' );
    is( $self->shop, undef, 'shop() called before SUPER::init()' );

    $self->SUPER::init;

    isa_ok( $self->shop, SHOP_PACKAGE, 'shop() called in test()' );
}

sub cleanup {
    my $self = shift;

    $self->SUPER::cleanup;

    isa_ok( $self->dbi, DBI_PACKAGE, 'dbi() called in cleanup()' );
    is( $self->shop, undef, 'shop() called after SUPER::cleanup()' );
}

__PACKAGE__->runScript;
